Class.create(function(Super)
 /**
  * JavaScriptDocument(=JSD)utitlevR}hNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsd.command.TitleNX
  * 
  * @package js.debug.jsd.command
  * @update 2007/09/30
  * @version 3.00.00
  * @author Mug
  * @copyright (C) 2005-2007 Mug, All right reserved.
  * 
  * @explanation <p>̃NXJavaScriptDocumentiȉJSDƗjR}ĥPł"title"R}h̃NXłB
  *   "title"R}h͊TvȒPɋLqB</p>
  *   <p>titleR}h͈ȉ̏ƏB<br />
  *   <div style="background-color:white;color:black;border:solid gray 1px;margin-left:1em;padding:1ex;">
  *   F<kbd style="background-color:#DDDDDD;white-space:nowrap;">@title Tv</kbd><br />
  *   F<br />
  *   <ul>
  *     <li>sLqFs</li>
  *     <li>oFs</li>
  *   </ul>
  *   <dl>
  *     <dt>PuTvviȗFC`FTextElementj</dt>
  *     <dd>TvLq́B</dd>
  *   </dl>
  *   </div>
  *   </p>
  * @rel js.debug.jsd.command.AbstractCommand
  * @rel js.debug.jsd.command.element.TextElement
  * 
  * @notice <p>"/**"n܂镡sRĝQsڂɃR}hł͂Ȃn܂镶񂪂ƂA
  *   ̍s"title"R}hłƔFB
  *   <pre><code>
  *     /**
  *      * TvLq
  *      * @notice ӎ
  *   iȍ~j
  *   </code></pre>
  *      Ĺ̗ALƓƂȂB<br />
  *   <pre><code>
  *     /**
  *      * @title TvLq
  *      * @notice ӎ
  *   iȍ~j
  *   </code></pre>
  *   </p>
  * 
  * @history 2007/09/30 3.00.00 vfNXg悤ɍ\ύX
  * @history 2006/02/18 2.00.00 ̋LqJn
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsd.command.Title";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //:C name String R}h
  Class.name = "title";
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S complexDefine Boolean ̃R}hPJSDŕLqł邩ǂiłj
  Static.complexDefine = true;
  
  //:S pattern RegExp ̃R}h̐K\
  Static.pattern = /^\s*(.*?)\s*$/;
  
  //------------------------------------------------------------------------------
  Static.parse = function(commandSource)
   /**
    * R}h\[X͂ăR}hCX^XԂ
    * @param commandSource String R}h\[X
    * @return js.debug.jsd.command.Title ̃R}hNX̃CX^X
    */
    {
    var obj = new Class();
    obj.autoDetect(commandSource);
    return obj;
    };
  //------------------------------------------------------------------------------
  Static.getElements = function()
   /**
    * ̃R}hŎgvf̃NX̔z擾
    * @return Array ̃R}hŎgvf̃NX̔z
    */
    {
    return [js.debug.jsd.command.element.TextElement];
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class()
   /**
    * JavaScriptDocument(JSD)utitlevR}hNX̃RXgN^
    * @return js.debug.jsd.command.Title TuNX̃CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  }, js.debug.jsd.command.AbstractCommand);

