Class.create(function(Super)
 /**
  * \[X́isircjNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsd.parser.MultiLineJsdParserNX
  * 
  * @package js.debug.jsd.parser
  * @update 2007/12/29
  * @version 1.01.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @history 2007/12/29 1.01.00 t@Ng[ɓo^悤ɕύX
  * @history 2007/10/06 1.00.00 VK쐬
  * 
  * @explanation <p>̃NXJSD̂߂̃\[XR[h͂ɂāAsRĝJSDRgJSDIuWFNgɕϊNXłB</p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsd.parser.MultiLineJsdParser";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.jsd.JsdFactory
  var JsdFactory = js.debug.jsd.JsdFactory;
  
  //:V AbstractCommand Function js.debug.jsd.command.AbstractCommand̎Q
  var AbstractCommand = js.debug.jsd.command.AbstractCommand;
  //:V JavaScriptDocument Function js.debug.jsd.JavaScriptDocument̎Q
  var JavaScriptDocument = js.debug.jsd.JavaScriptDocument;
  //:V SourcePoint Function js.debug.jsd.parser.SourcePoint̎Q
  var SourcePoint = js.debug.jsd.parser.SourcePoint;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V JSD_PATTERN RegExp JSD̋Lqp^[
  var JSD_PATTERN = /^\/\*\*((?:.|\r|\n)*)\*\/$/;
  //:V CMD_PATTERN RegExp JSDR}hJns̋Lqp^[
  var CMD_PATTERN = /^(?:\s*\*)?\s*@(\S+)(?:\s+(.*?))?$/;
  //:V CMT_PATTERN RegExp JSDRg̋Lqp^[
  var CMT_PATTERN = /^(?:\s*\*)?(.*?)$/;
  //:V DEFAULT_COMMAND String Psڂŏȗ\JSDR}hutitlev
  var DEFAULT_COMMAND = "title";
  
  //:V cmdClassCache Object R}hNX̃LbV(L[=R}h, l=R}hNX)
  var cmdClassCache = {};
  
  //------------------------------------------------------------------------------
  function findLineSeparator(src)
   /**
    * sR[h
    * @param src String 팟
    * @return String sR[hiKLF,CR,CRLF,LFCR̂ꂩԂj
    */
    {
    if(!src)
      {
      return "\n";
      }
    else if(src.indexOf("\r", 0) < 0)
      {
      return "\n";
      }
    else if(src.indexOf("\n", 0) < 0)
      {
      return "\r";
      }
    else if(src.indexOf("\r\n", 0) >= 0)
      {
      return "\r\n";
      }
    else if(src.indexOf("\n\r", 0) >= 0)
      {
      return "\n\r";
      }
    else
      {
      return "\n";
      }
    }
  //------------------------------------------------------------------------------
  function adjustSpace(src, LS)
   /**
    * sR}h̃R}h\[XɂāAQsڈȍ~̐擪󔒂𒲐
    * @param src String R}h\[X
    * @param LS String sR[h
    * @return String ꂽR}h\[X
    */
    {
    if(src && ((typeof src) == "string"))
      {
      if(src.indexOf(LS, 0) >= 0)
        {
        var topSp = /^(\s+)/;
        var lines = src.split(LS);
        var minSp = -1;
        for(var i = 1; i < lines.length; i++)
          {
          if(topSp.test(lines[i]))
            {
            topSp.exec(lines[i]);
            minSp = (minSp < 0) ? RegExp.$1.length : Math.min(minSp, RegExp.$1.length);
            }
          else
            {
            minSp = 0;
            break;
            }
          }
        if(minSp > 0)
          {
          for(var i = 1; i < lines.length; i++)
            {
            lines[i] = lines[i].substring(minSp, lines[i].length);
            }
          src = lines.join(LS);
          }
        lines = null;
        }
      }
    return src;
    }
  //------------------------------------------------------------------------------
  function getCommandClassByCommand(command)
   /**
    * R}hR}hNX擾
    * @condition YR}hNX(js.debug.jsd.command.*)CN[hς݂ł邱ƁB
    * @param command String R}h
    * @return Function|null R}hNXiYȂ̏ꍇnullԂj
    */
    {
    if(((typeof cmdClassCache[command]) == "function") && (cmdClassCache[command].prototype instanceof AbstractCommand))
      {
      return cmdClassCache[command];
      }
    var pack = js.debug.jsd.command;
    for(var name in pack)
      {
      if(((typeof pack[name]) == "function") && (pack[name].prototype instanceof AbstractCommand) && ((typeof pack[name].name) == "string"))
        {
        if(!cmdClassCache[pack[name].name] || ((typeof cmdClassCache[pack[name].name]) != "function") || !(cmdClassCache[pack[name].name].prototype instanceof AbstractCommand))
          {
          cmdClassCache[pack[name].name] = pack[name];
          }
        if(pack[name].name == command)
          {
          return pack[name];
          }
        }
      }
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S PATTERN RegExp|null Y(/(\/\*\*(?:.|\r|\n)*?\*\/)/g)
  Static.PATTERN = /(\/\*\*(?:.|\r|\n)*?\*\/)/g;
  //:S ALTERNATE String|null ֕i󕶎j
  Static.ALTERNATE = "";
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.parse = function(aroundSource)
   /**
    * \[XJSDIuWFNgɃp[X
    * @condition aroundSource̓RgO\[XłȂ΂ȂȂB
    * @param aroundSource [Array|String|null] ͂̃\[X
    * @return js.debug.jsd.JavaScriptDocument|null ͂ĐꂽJSDCX^X
    * @throw StringFormatException@Error RXgN^rangevaluevpeBv~eBuString^łȂꍇ
    * @throw StringRangeException@Error RXgN^rangevaluevpeBϐJSD_PATTERN̐K\𖞂Ȃꍇ
    * @throw FormatException@Error aroundSourceArray^łv~eBuString^łnullł`łȂꍇ
    * @throw StringFormatException@Error aroundSourceArray^ł̗vfɃv~eBuString^łȂ̂܂܂Ăꍇ
    */
    {
    var range = this.getRange();
    if((typeof range.value) != "string")
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"range.value", value:range.value, type:(typeof range.value)});
      }
    if(!JSD_PATTERN.test(range.value))
      {
      throw new Error("StringRangeException", Creator.CompleteName, {variable:"range.value", range:("/"+JSD_PATTERN.source+"/"), value:range.value, type:(typeof range.value)});
      }
    if((aroundSource !== undefined) && (aroundSource !== null) && ((typeof aroundSource) != "string") && !(aroundSource instanceof Array))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"aroundSource", format:"[Array|String|null]", value:aroundSource, type:(typeof aroundSource)});
      }
    if(aroundSource instanceof Array)
      {
      for(var i = 0; i < aroundSource.length; i++)
        {
        if((typeof aroundSource[i]) != "string")
          {
          throw new Error("StringFormatException", Creator.CompleteName, {variable:("aroundSource["+i+"]"), value:aroundSource[i], type:(typeof aroundSource[i])});
          }
        }
      }
    // 
    if((typeof aroundSource) == "string")
      {
      if(!aroundSource)
        {
        aroundSource = null;
        }
      else if(aroundSource.indexOf("\r", 0) < 0)
        {
        aroundSource = aroundSource.split("\n");
        }
      else if(aroundSource.indexOf("\n", 0) < 0)
        {
        aroundSource = aroundSource.split("\r");
        }
      else
        {
        aroundSource = aroundSource.replace(/\r/g, "").split("\n");
        }
      }
    // JSDCX^X̐
    var jsd  = new JavaScriptDocument();
    var source = JSD_PATTERN.exec(range.value)[1];
    var LS = findLineSeparator(source);
    var lines = source.split(LS);
    var cmdClass = null;
    // Pŝ݂̂Ƃ
    if(lines.length == 1)
      {
      cmdClass = getCommandClassByCommand(DEFAULT_COMMAND);
      jsd.addCommand(cmdClass.Static.parse(lines[0]));
      cmdClass = null;
      }
    // ŝƂ
    else
      {
      for(var n = 1; n < lines.length; n++)
        {
        // sR}hp
        if(cmdClass)
          {
          // ̍sVR}h
          if(CMD_PATTERN.test(lines[n]))
            {
            jsd.addCommand(cmdClass.Static.parse(adjustSpace(source, LS)));
            cmdClass = null;
            }
          // sR}hp
          else
            {
            source += LS + (CMT_PATTERN.test(lines[n]) ? CMT_PATTERN.exec(lines[n])[1] : lines[n]);
            }
          // ̍sŏI
          if(cmdClass && (n == (lines.length - 1)))
            {
            jsd.addCommand(cmdClass.Static.parse(adjustSpace(source, LS)));
            }
          }
        // R}h̊Jns
        if(!cmdClass)
          {
          // R}hR}hNX擾
          if(CMD_PATTERN.test(lines[n]))
            {
            CMD_PATTERN.exec(lines[n]);
            cmdClass = getCommandClassByCommand(RegExp.$1);
            source = RegExp.$2;
            }
          else if((n <= 1) && CMT_PATTERN.test(lines[n]))
            {
            cmdClass = getCommandClassByCommand(DEFAULT_COMMAND);
            source = CMT_PATTERN.exec(lines[n])[1];
            }
          // R}hNX
          if(cmdClass)
            {
            // PsR}horsR}hōŏIs
            if(!cmdClass.Static.multipleLines || (n >= (lines.length - 1)))
              {
              jsd.addCommand(cmdClass.Static.parse(source));
              cmdClass = null;
              }
            }
          }
        }
      }
    this.jsd = jsd;
    // ^[Qbǧ
    if(aroundSource)
      {
      var name = jsd.getCommandByName("name");
      if(name)
        {
        name = name.getValue(name.getNames()[0]);
        }
      var def  = jsd.getCommandByName("def");
      if(def)
        {
        def = def.getValue(def.getNames()[0]).toUpperCase();
        }
      var target = null;
      // s(O)
      if(!target && (range.begin instanceof SourcePoint) && ((typeof range.begin.lineNumber) == "number") && (0 <= range.begin.lineNumber) && (aroundSource.length > range.begin.lineNumber))
        {
        var src = aroundSource[range.begin.lineNumber];
        if(((typeof range.begin.charIndex) == "number") && (0 <= range.begin.charIndex) && (range.begin.charIndex < src.length))
          {
          src = src.substring(0, range.begin.charIndex);
          }
        target = Static.findTarget(src);
        if(target)
          {
          target.begin.lineNumber = range.begin.lineNumber;
          target.end.lineNumber = range.begin.lineNumber;
          }
        if(target && ((name && (target.value != name)) || (def && (target.def.toUpperCase() != def))))
          {
          target = null;
          }
        }
      // s()
      if(!target && (range.end instanceof SourcePoint) && ((typeof range.end.lineNumber) == "number") && (0 <= range.end.lineNumber) && (aroundSource.length > range.end.lineNumber))
        {
        var src = aroundSource[range.end.lineNumber];
        if(((typeof range.end.charIndex) == "number") && (0 <= range.end.charIndex))
          {
          src = (range.end.charIndex < src.length) ? src.substring(range.end.charIndex, src.length) : "";
          }
        target = Static.findTarget(src);
        if(target)
          {
          target.begin.lineNumber = range.en.lineNumber;
          target.end.lineNumber = range.en.lineNumber;
          }
        if(target && ((name && (target.value != name)) || (def && (target.def.toUpperCase() != def))))
          {
          target = null;
          }
        }
      // ̍s
      if(!target && (range.end instanceof SourcePoint) && ((typeof range.end.lineNumber) == "number") && (0 <= (range.end.lineNumber + 1)) && (aroundSource.length > (range.end.lineNumber + 1)))
        {
        var src = aroundSource[range.end.lineNumber + 1];
        target = Static.findTarget(src);
        if(target)
          {
          target.begin.lineNumber = range.end.lineNumber + 1;
          target.end.lineNumber = range.end.lineNumber + 1;
          }
        if(target && ((name && (target.value != name)) || (def && (target.def.toUpperCase() != def))))
          {
          target = null;
          }
        }
      // O̍s
      if(!target && (range.begin instanceof SourcePoint) && ((typeof range.begin.lineNumber) == "number") && (0 <= (range.begin.lineNumber - 1)) && (aroundSource.length > (range.begin.lineNumber - 1)))
        {
        var src = aroundSource[range.begin.lineNumber - 1];
        target = Static.findTarget(src);
        if(target)
          {
          target.begin.lineNumber = range.begin.lineNumber - 1;
          target.end.lineNumber = range.begin.lineNumber - 1;
          }
        if(target && ((name && (target.value != name)) || (def && (target.def.toUpperCase() != def))))
          {
          target = null;
          }
        }
      // ^[Qbgm
      if(target)
        {
        this.target = target;
        }
      }
    // JSDCX^X̕ԋp
    return jsd;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  // t@Ng[ɓo^
  JsdFactory.registParser(Class);
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(range)
   /**
    * \[X́isircjNX̃RXgN^
    * @param range js.debug.jsd.parser.SourceRange ͑Ώۂ̃\[X͈̔͂ƒl
    * @return js.debug.jsd.parser.MultiLineJsdParser ̃NX̃CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  }, js.debug.jsd.parser.AbstractParser);

